package net.pocketmagic.android.CustomComplexListview;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.Typeface;
import android.text.TextWatcher;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.ToggleButton;
import java.util.List;

/* custom complex listview sample for Android 
 * 
 * (C) 2011 Radu Motisan
 * radu.motisan@gmail.com
 * www.pocketmagic.net
 * 
 * This code is copyrighted. You can use it in your home/non-commercial applications only.
 * 
 * To extend your rights, contact Radu Motisan.
 */


class CustomAdapterView extends LinearLayout {        
	public CustomAdapterView(final Context context, CustomAdapterItem item, int position, int total,CustomAdapterItem prevItem) 
	{
		super( context );		
		setId(item.getItemID());
		setOnClickListener((OnClickListener) context);
		
		    
		//container is a horizontal layer
		setOrientation(LinearLayout.HORIZONTAL);
		setPadding(0, 0, 0, 0);
		
		//check current item in list
		boolean isEmpty = ( (item.getFirstName().length() == 0) &&
							(item.getLastName().length() == 0));
							
		
		boolean isPrevEmpty = false;
		if (prevItem == null) 
			isPrevEmpty = true;
		else 
			isPrevEmpty = ( (prevItem.getFirstName().length() == 0) &&
					(prevItem.getLastName().length() == 0));
		//header
		if (position == 0) {
			setBackgroundColor(Color.rgb(0,0,0));
			RelativeLayout PanelH = new RelativeLayout(context);
	  		PanelH.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT));
	  		PanelH.setPadding(0,0,0,6);
	  		
			final EditText et = new EditText(context);
			String text = item.getFirstName();
			if (text.length() == 0) et.setText("");
			else et.setText(text);
			item.setView(et);
			et.setId(CustomComplexListview.idFilterEdit);
			et.setBackgroundResource(R.drawable.edit);
	  		et.addTextChangedListener((TextWatcher) context);
			RelativeLayout.LayoutParams layoutparams = new RelativeLayout.LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT);
			layoutparams.leftMargin = 0;
			layoutparams.topMargin = 0;
			PanelH.addView(et, layoutparams);
			
			final ToggleButton b1 = new ToggleButton(context), 
	  						   b2 = new ToggleButton(context);
			b1.setId(CustomComplexListview.idFilterFirstname);
	  		b1.setText("First");
	  		b1.setTextOff("First");
	  		b1.setTextOn("First");
	  		b1.setPadding(0, 0, 0, 0);
	  		b1.setTextColor(Color.rgb(255,255,255));
	  		b1.setBackgroundDrawable(getResources().getDrawable(R.drawable.filter_left));
	  		b1.setTextSize(10);
	  		b1.setTypeface(Typeface.create("arial", Typeface.BOLD));
	  		b1.setOnClickListener(new OnClickListener() 
	  		{
	  			public void onClick(View v) {
	  				b2.setChecked(false);
	  				((CustomComplexListview)context).onClick(v);
	  			}
	  		});
	  		RelativeLayout.LayoutParams layoutparams1 = new RelativeLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
			layoutparams1.addRule(RelativeLayout.BELOW, CustomComplexListview.idFilterEdit);
			layoutparams1.addRule(RelativeLayout.ALIGN_PARENT_LEFT);
			PanelH.addView(b1, layoutparams1);
			
			b2.setId(CustomComplexListview.idFilterLastname);
			b2.setText("Last");
	  		b2.setTextOff("Last");
	  		b2.setTextOn("Last");
	  		b2.setPadding(0, 0, 0, 0);
	  		b2.setTextColor(Color.rgb(255,255,255));
	  		b2.setBackgroundDrawable(getResources().getDrawable(R.drawable.filter_right));
	  		b2.setTextSize(10);
	  		b2.setTypeface(Typeface.create("arial", Typeface.BOLD));
	  		b2.setOnClickListener(new OnClickListener() 
	  		{
	  			public void onClick(View v) {
	  				b1.setChecked(false); 
	  				((CustomComplexListview)context).onClick(v);
	  			}
	  		});
	  		RelativeLayout.LayoutParams layoutparams2 = new RelativeLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
			layoutparams2.addRule(RelativeLayout.BELOW, CustomComplexListview.idFilterEdit);
			layoutparams2.addRule(RelativeLayout.ALIGN_PARENT_RIGHT);
			PanelH.addView(b2, layoutparams2);
			
	  		addView(PanelH);
		} 
		else if (position == total - 1) {
			//-- this is the LAST LV ITEM --//
			ImageView ivFinalHolder = new ImageView(context);
			if (isPrevEmpty)
				ivFinalHolder.setImageDrawable(context.getResources().getDrawable(R.drawable.ch_last_empty));
			else 
				ivFinalHolder.setImageDrawable(context.getResources().getDrawable(R.drawable.ch_last));
			
			addView(ivFinalHolder);
		}
		else {
			RelativeLayout PanelH = new RelativeLayout(context);
	  		PanelH.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT));
	  		setPadding(0,0,0,0);
			//image:itself
			ImageView ivHolder = new ImageView(context);
			// load image
			if (position == 1)	//-- this is the FIRST LV ITEM --//
				ivHolder.setImageDrawable(context.getResources().getDrawable(R.drawable.ch_first));
			else //-- this is a REGULAR LV ITEM --// 
			{
				if (isEmpty) {
					if (isPrevEmpty && position>2) //we always put an ender after the first item: position=2
						ivHolder.setImageDrawable(context.getResources().getDrawable(R.drawable.ch_empty));
					else
						ivHolder.setImageDrawable(context.getResources().getDrawable(R.drawable.ch_ender));
				}
				else 
					ivHolder.setImageDrawable(context.getResources().getDrawable(R.drawable.ch_normal));
				
			}
			//image:add
			RelativeLayout.LayoutParams layoutparams1 = new RelativeLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
			PanelH.addView(ivHolder, layoutparams1);
			
			if (position == 1 && item.getItemID() == 0) //empty first item!
			{
				TextView textEmpty = new TextView( context );
				textEmpty.setTextSize(16);
				textEmpty.setTypeface(Typeface.DEFAULT, Typeface.BOLD);
				textEmpty.setTextColor(Color.rgb(0,0,0));
				//textEmpty.setBackgroundColor(Color.rgb(255,255,0));
				textEmpty.setText( "      "+"No ITEMS in LIST" +"      ");
				RelativeLayout.LayoutParams layoutparams = new RelativeLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
				layoutparams.addRule(RelativeLayout.CENTER_IN_PARENT);
				PanelH.addView(textEmpty, layoutparams);
			} else if (!isEmpty) {
				//image
				ImageView ivImg = new ImageView(context);
				ivImg.setImageDrawable(getResources().getDrawable(R.drawable.icon));
				RelativeLayout.LayoutParams layoutparams2 = new RelativeLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
				layoutparams2.addRule(RelativeLayout.CENTER_HORIZONTAL);
				layoutparams2.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
				PanelH.addView(ivImg, layoutparams2);

				
				TextView textName = new TextView( context );
				textName.setTextSize(16);
				textName.setTypeface(Typeface.DEFAULT, Typeface.BOLD);
				textName.setTextColor(Color.rgb(0,0,0));
				textName.setText( item.getFirstName() + " " + item.getLastName());// + "\n\m" + item.getCompany());//+ " POS:"+position + "/"+total);
				RelativeLayout.LayoutParams layoutparams3 = new RelativeLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
				layoutparams3.addRule(RelativeLayout.CENTER_IN_PARENT);
				PanelH.addView(textName, layoutparams3);
			}
			//add this panel to final item
			addView(PanelH);
		}
	}
}

public class CustomAdapter extends BaseAdapter /*implements OnClickListener*/ {
	

	public static final String LOG_TAG = "BI::CA";
    private Context context;
    private List<CustomAdapterItem> itemList;

    public CustomAdapter(Context context, List<CustomAdapterItem> itemList  ) { 
        this.context = context;
        this.itemList = itemList;
    }

    public int getCount() {                        
        return itemList.size();
    }

    public Object getItem(int position) {     
        return itemList.get(position);
    }

    public long getItemId(int position) {  
        return position;
    }

    public View getView(int position, View convertView, ViewGroup parent) 
    { 
    	CustomAdapterItem item = itemList.get(position);
    	CustomAdapterItem prevItem = null;
    	if (position > 0) prevItem = itemList.get(position-1);
        View v = new CustomAdapterView(this.context, item, position, itemList.size(), prevItem );
        //v.setBackgroundColor((position % 2) == 1 ? Color.GRAY : Color.BLACK);
        return v;
    }
}


/* custom complex listview sample for Android 
 * 
 * (C) 2011 Radu Motisan
 * radu.motisan@gmail.com
 * www.pocketmagic.net
 * 
 * This code is copyrighted. You can use it in your home/non-commercial applications only.
 * 
 * To extend your rights, contact Radu Motisan.
 */
