package net.pocketmagic.android.CustomComplexListview;

import java.util.ArrayList;

import android.app.Activity;
import android.content.DialogInterface;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.Toast;

/* custom complex listview sample for Android 
 * 
 * (C) 2011 Radu Motisan
 * radu.motisan@gmail.com
 * www.pocketmagic.net
 * 
 * This code is copyrighted. You can use it in your home/non-commercial applications only.
 * 
 * To extend your rights, contact Radu Motisan.
 */

public class CustomComplexListview extends Activity  implements OnClickListener, TextWatcher {
    /** Called when the activity is first created. */
	private ListView 					m_lv;
	CustomAdapter 						m_lvAdapter;
	CustomAdapterItem					m_lvHeaderItem;

	static int 							idFilterFirstname = Menu.FIRST + 1,
										idFilterLastname = Menu.FIRST + 2,
										idFilterEdit = Menu.FIRST + 3,
										idLVFirstItem	 = Menu.FIRST + 100;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        m_lv = new ListView(this);
        
        ArrayList<CustomAdapterItem> m_lvItems = new ArrayList<CustomAdapterItem>();
   		//
   		//add Header
   		m_lvHeaderItem = new CustomAdapterItem("","",0); //add header
   		m_lvItems.add(m_lvHeaderItem);
   		//add items
   		CustomAdapterItem lvItem;

   		int items = 0;
   		
   		lvItem = new CustomAdapterItem( "Radu", "Motisan", idLVFirstItem+items);
       	m_lvItems.add(lvItem);
       	items++;

       	lvItem = new CustomAdapterItem( "PocketMagic", ".net", idLVFirstItem+items);
       	m_lvItems.add(lvItem);
       	items++;

       	lvItem = new CustomAdapterItem( "Complex", "Listview", idLVFirstItem+items);
       	m_lvItems.add(lvItem);
       	items++;

	    // add extra items to fill the rest of the listview: we need 4 items at least!
	    for (int i=0;i<4-items;i++) {
	      	lvItem = new CustomAdapterItem("","", 0);
	       	m_lvItems.add(lvItem);
	    }
	    
	    //add Footer
	    lvItem = new CustomAdapterItem("","",0); //add footer: must be last item!
   		m_lvItems.add(lvItem);
   		//create the Adapter
   		if (m_lvAdapter == null) m_lvAdapter =  new CustomAdapter(this, m_lvItems);
   		//Add adapter to Listview
   		m_lv.setAdapter((ListAdapter) m_lvAdapter);
        // Configure listview: no divider, no focusable, etc
   		m_lv.setDividerHeight(0);
   		m_lv.setScrollBarStyle(0);
   		m_lv.setSelection(1);
   		m_lv.setFocusable(false);

        
        
        setContentView(m_lv);
    }
	public void afterTextChanged(Editable arg0) {
		// TODO Auto-generated method stub
		
	}
	public void beforeTextChanged(CharSequence s, int start, int count,
			int after) {
		// TODO Auto-generated method stub
		
	}
	public void onTextChanged(CharSequence s, int start, int before, int count) {
		// TODO Auto-generated method stub
		
	}
	public void onClick(View v) {
		// TODO Auto-generated method stub
		int id = v.getId();
		Toast.makeText(getBaseContext(), "Click on:"+id, Toast.LENGTH_SHORT).show();
		
	}
}
/* custom complex listview sample for Android 
 * 
 * (C) 2011 Radu Motisan
 * radu.motisan@gmail.com
 * www.pocketmagic.net
 * 
 * This code is copyrighted. You can use it in your home/non-commercial applications only.
 * 
 * To extend your rights, contact Radu Motisan.
 */
